#include "ObjectRelationalAccess/ObjectRelationalNames.h"
#include <sstream>

std::string
pool::ObjectRelationalAccess::serviceName(){
  static std::string serviceName = "POOL/ObjectRelationalAccess";
  return serviceName;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::moduleName()
{
  static std::string s_moduleName = "ObjectRelationalAccess";
  return s_moduleName;
}


std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::objectMappingElementType()
{
  static std::string s_objectMappingElementType = "Object";
  return s_objectMappingElementType;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::primitiveMappingElementType()
{
  static std::string s_primitiveMappingElementType = "Primitive";
  return s_primitiveMappingElementType;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::arrayMappingElementType()
{
  static std::string s_arrayMappingElementType = "Array";
  return s_arrayMappingElementType;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::CArrayMappingElementType()
{
  static std::string s_CArrayMappingElementType = "CArray";
  return s_CArrayMappingElementType;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::inlineCArrayMappingElementType()
{
  static std::string s_inlineCArrayMappingElementType = "InlineCArray";
  return s_inlineCArrayMappingElementType;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::poolReferenceMappingElementType()
{
  static std::string s_poolReferenceMappingElementType = "PoolReference";
  return s_poolReferenceMappingElementType;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::poolPointerMappingElementType()
{
  static std::string s_poolPointerMappingElementType = "PoolPointer";
  return s_poolPointerMappingElementType;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::pointerMappingElementType()
{
  static std::string s_pointerMappingElementType = "Pointer";
  return s_pointerMappingElementType;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::referenceMappingElementType()
{
  static std::string s_referenceMappingElementType = "Reference";
  return s_referenceMappingElementType;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::blobMappingElementType()
{
  static std::string s_blobMappingElementType = "Blob";
  return s_blobMappingElementType;
}

bool
pool::ObjectRelationalAccess::ObjectRelationalNames::isValidMappingElementType( const std::string& elementType )
{
  return ( elementType == pool::ObjectRelationalAccess::ObjectRelationalNames::objectMappingElementType() ||
           elementType == pool::ObjectRelationalAccess::ObjectRelationalNames::primitiveMappingElementType() ||
           elementType == pool::ObjectRelationalAccess::ObjectRelationalNames::arrayMappingElementType() ||
           elementType == pool::ObjectRelationalAccess::ObjectRelationalNames::CArrayMappingElementType() ||
           elementType == pool::ObjectRelationalAccess::ObjectRelationalNames::inlineCArrayMappingElementType() ||
           elementType == pool::ObjectRelationalAccess::ObjectRelationalNames::poolReferenceMappingElementType() ||
           elementType == pool::ObjectRelationalAccess::ObjectRelationalNames::poolPointerMappingElementType() ||
           elementType == pool::ObjectRelationalAccess::ObjectRelationalNames::pointerMappingElementType() ||
           elementType == pool::ObjectRelationalAccess::ObjectRelationalNames::referenceMappingElementType() ||
           elementType == pool::ObjectRelationalAccess::ObjectRelationalNames::blobMappingElementType() );
}


std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::mappingVersionTable()
{
  static std::string s_mappingVersionTable = "POOL_OR_MAPPING_VERSIONS";
  return s_mappingVersionTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::versionFieldInMappingVersionTable()
{
  static std::string s_versionFieldInMappingVersionTable = "MAPPING_VERSION";
  return s_versionFieldInMappingVersionTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::containerNameFieldInMappingVersionTable()
{
  static std::string s_containerNameFieldInMappingVersionTable = "CONTAINER_ID";
  return s_containerNameFieldInMappingVersionTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::classVersionTable()
{
  static std::string s_classVersionTable = "POOL_OR_CLASS_VERSIONS";
  return s_classVersionTable;
  
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::classVersionFieldInClassVersionTable()
{
  static std::string s_classVersionFieldInClassVersionTable = "CLASS_VERSION";
  return s_classVersionFieldInClassVersionTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::containerNameFieldInClassVersionTable()
{
  static std::string s_containerNameFieldInClassVersionTable = "CONTAINER_ID";
  return s_containerNameFieldInClassVersionTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::mappingVersionFieldInClassVersionTable()
{
  static std::string s_mappingVersionFieldInClassVersionTable = "MAPPING_VERSION";
  return s_mappingVersionFieldInClassVersionTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::mappingElementTable()
{
  static std::string s_mappingElementTable = "POOL_OR_MAPPING_ELEMENTS";
  return s_mappingElementTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::elementTypeFieldInMappingElementTable()
{
  static std::string s_elementTypeFieldInMappingElementTable = "ELEMENT_TYPE";
  return s_elementTypeFieldInMappingElementTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::scopeNameFieldInMappingElementTable()
{
  static std::string s_scopeNameFieldInMappingElementTable = "SCOPE_NAME";
  return s_scopeNameFieldInMappingElementTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::variableNameFieldInMappingElementTable()
{
  static std::string s_variableNameFieldInMappingElementTable = "VARIABLE_NAME";
  return s_variableNameFieldInMappingElementTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::variableTypeFieldInMappingElementTable()
{
  static std::string s_variableTypeFieldInMappingElementTable = "VARIABLE_TYPE";
  return s_variableTypeFieldInMappingElementTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::tableNameFieldInMappingElementTable()
{
  static std::string s_tableNameFieldInMappingElementTable = "TABLE_NAME";
  return s_tableNameFieldInMappingElementTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::versionFieldInMappingElementTable()
{
  static std::string s_positionFieldInMappingElementTable = "VERSION";
  return s_positionFieldInMappingElementTable;
}


std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::mappingElementColumnsTable()
{
  static std::string s_mappingElementColumnsTable = "POOL_OR_MAPPING_COLUMNS";
  return s_mappingElementColumnsTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::versionFieldInMappingElementColumnsTable()
{
  static std::string s_versionFieldInMappingElementColumnsTable = "VERSION";
  return s_versionFieldInMappingElementColumnsTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::scopeNameFieldInMappingElementColumnsTable()
{
  static std::string s_scopeNameFieldInMappingElementColumnsTable = "SCOPE_NAME";
  return s_scopeNameFieldInMappingElementColumnsTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::variableNameFieldInMappingElementColumnsTable()
{
  static std::string s_variableNameFieldInMappingElementColumnsTable = "VARIABLE_NAME";
  return s_variableNameFieldInMappingElementColumnsTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::columnFieldInMappingElementColumnsTable()
{
  static std::string s_columnFieldInMappingElementColumnsTable = "COLUMN_NAME";
  return s_columnFieldInMappingElementColumnsTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::positionFieldInMappingElementColumnsTable()
{
  static std::string s_positionFieldInMappingElementColumnsTable = "POSITION";
  return s_positionFieldInMappingElementColumnsTable;
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::foreignKeyNameInMappingElementColumnsTable()
{
  static std::string s_foreignKeyNameInMappingElementColumnsTable = pool::ObjectRelationalAccess::ObjectRelationalNames::mappingElementColumnsTable() + "_FK";
  return s_foreignKeyNameInMappingElementColumnsTable;
}


std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::indexNameForIdentity( const std::string& tableName )
{
  return tableName + "_ID_IDX";
}


std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::fkNameForIdentity( const std::string& tableName )
{
  return tableName + "_ID_FK";
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::newMappingVersionForClass( const std::string& className, int iteration )
{
  std::ostringstream os;
  os << className;
  os << "_";
  if ( iteration > 0 ) {
    if ( iteration < 10 ) os << "0";
    if ( iteration < 100 ) os << "0";
    os << iteration;
  } else {
    os << "000";
  }
  
  return os.str();
}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::classVersionPropertyNameInDictionary()
{
  static std::string s_propertyName("class_version");
  return s_propertyName;

}

std::string
pool::ObjectRelationalAccess::ObjectRelationalNames::defaultClassVersion(const std::string& className)
{
  std::string classVersion(className);
  classVersion.append("_default");
  return classVersion;
}

