#ifndef RELATIONALCOLLECTION_DBLOCK_H
#define RELATIONALCOLLECTION_DBLOCK_H


#include "RelationalAccess/ISessionProxy.h"

namespace pool {
   namespace RelationalCollection {
      
      class DBLock
      {
     public:
        DBLock( coral::ISessionProxy& session, std::string collName );
        ~DBLock();
 
        /// set a global lock to serialize collection operations (creation etc)
        /// if XTrans is flase, the lock will be gone when transaction is committed
        /// if XTrans is true, the lock will be permanent
        void lock( bool Xtrans );
 
        /// remove global lock
        void unlock();
 
     private:
 
        /// Reference to current database access session.
        coral::ISessionProxy& m_session;
 
        std::string           m_name;
        bool                  m_locked;
      };
 
      
   }
}

#endif


