#include "PoolContainerManagerFactory.h"
#include "PoolPrimitivesContainerManager.h"
#include "PoolHomogeneousContainerManager.h"
#include "PoolPolymorphicContainerManager.h"

pool::RelationalStorageService::PoolBaseContainerManager*
pool::RelationalStorageService::PoolContainerManagerFactory::newPrimitivesContainer( int containerId,
                                                                                     coral::ISchema& schema,
                                                                                     const std::string& containerTableName )
{
  return new pool::RelationalStorageService::PoolPrimitivesContainerManager( containerId,
                                                                             schema, 
                                                                             containerTableName );
}



pool::RelationalStorageService::PoolBaseContainerManager*
pool::RelationalStorageService::PoolContainerManagerFactory::newHomogeneousContainer( int containerId,
                                                                                      coral::ISchema& schema,
                                                                                      const pool::RelationalStorageService::MappingInformation& mapping )
{
  return new pool::RelationalStorageService::PoolHomogeneousContainerManager( containerId,
                                                                              schema, 
                                                                              mapping );
}



pool::RelationalStorageService::PoolBaseContainerManager*
pool::RelationalStorageService::PoolContainerManagerFactory::newPolymorphicContainer( int containerId,
                                                                                      const std::string& containerName,
                                                                                      coral::ISchema& schema,
                                                                                      const std::string& containerTableName,
                                                                                      pool::RelationalStorageService::MappingManager& mappingManager,
                                                                                      pool::RelationalStorageService::MappingSequence& mappingSequences )

{
  return new pool::RelationalStorageService::PoolPolymorphicContainerManager( containerId,
                                                                              containerName,
                                                                              schema,
                                                                              containerTableName,
                                                                              mappingManager,
                                                                              mappingSequences );
}
