#include "TestDriver.h"
#include <cstdlib>
#include <stdexcept>
#ifdef _WIN32
#include <windows.h>
#endif
int main( int,char**) {

  // Set the authentication path
#ifdef _WIN32
	 const char* CoralEVar =  "CORAL_AUTH_PATH";
	 ::SetEnvironmentVariable(CoralEVar,"/afs/cern.ch/sw/lcg/app/pool/db");

	 const char* DBEVar =  "CORAL_DBLOOKUP_PATH";
	 ::SetEnvironmentVariable(DBEVar,"/afs/cern.ch/sw/lcg/app/pool/db");
#else
  if( ! ::getenv("CORAL_AUTH_PATH" ) ){
    ::putenv( "CORAL_AUTH_PATH=/afs/cern.ch/sw/lcg/app/pool/db");
  }
  if( ! ::getenv("CORAL_DBLOOKUP_PATH" ) ){
    ::putenv( "CORAL_DBLOOKUP_PATH=/afs/cern.ch/sw/lcg/app/pool/db");
  }
#endif
 
  try{
    pool::TestDriver test("/pool/db/service_1");
    test.run();    
    std::cout << "[OVAL] Test completed."<<std::endl;
  } catch (const std::exception& e){
    std::cout << "[OVAL] ERROR: " << e.what() << std::endl;
    return 1;
  }
  return 0;
}
